//+------------------------------------------------------------------+
//|                                                 II_CrashZone.mq4 |
//|                            Copyright  2010, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| v.1.2 21/3/2010                                                  |
//| code by bredin, except where noted                               |
//| idea by mightyone                                                |
//| donations can be made via PayPal to bredin@lpemail.com           |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Insanity Industries"
#property link      "http://www.insanityindustries.net"

#property indicator_chart_window
extern bool weekly.extreme.on = false;
extern bool target.long = true;
extern bool target.short = true;
extern color color.cz.long = LimeGreen;
extern color color.cz.short = Red;
extern int line.style = 0;
extern int line.width = 0;


double cz.level.array[5]={0,0.667,0.833,1.167,1.333};
string cz.level.desc.long[5]={"W1 Low : ","Target 1 : ","","Target 2 : ",""};
string cz.level.desc.short[5]={"W1 High : ","Target 1 : ","","Target 2 : ",""};
string TAG = "II_CrashZone";

double LOW,HIGH,TIME;

int init()
{
   if(!weekly.extreme.on){
      for(int i=0;i<4;i++){
         cz.level.array[i]=cz.level.array[i+1];
         cz.level.desc.long[i]=cz.level.desc.long[i+1];
         cz.level.desc.short[i]=cz.level.desc.short[i+1];
      }
      ArrayResize(cz.level.array,4);
      ArrayResize(cz.level.desc.long,4);
      ArrayResize(cz.level.desc.short,4);
   }
   return(0);
}


int deinit()
{
   ObjectDelete(TAG+"CZHI");
   ObjectDelete(TAG+"CZLO");   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double range[3];
   string s,d;
   int i,j;
   for(i=1;i<4;i++) range[i-1] = iHigh(NULL,PERIOD_W1,i) - iLow(NULL,PERIOD_W1,i);
   ArraySort(range);
   int level_count = ArraySize(cz.level.array);
   
   TIME = iTime(NULL,PERIOD_W1,0);
   
   if(target.long){
      LOW = iLow(NULL,PERIOD_W1,0);
      s = TAG+"CZHI";
      ObjectDelete(s);
      ObjectCreate(s, OBJ_FIBO, 0,TIME,LOW+range[1],TIME,LOW);
      ObjectSet(s, OBJPROP_COLOR, CLR_NONE);
      ObjectSet(s, OBJPROP_STYLE, line.style);
      ObjectSet(s, OBJPROP_WIDTH, line.width);
      ObjectSet(s, OBJPROP_RAY, true);
      ObjectSet(s, OBJPROP_BACK, true);  
      ObjectSet(s, OBJPROP_FIBOLEVELS, level_count);
      ObjectSet(s, OBJPROP_LEVELCOLOR, color.cz.long);

      for(j=0; j<level_count; j++){
         ObjectSet(s, OBJPROP_FIRSTLEVEL+j, cz.level.array[j]);
         d = cz.level.desc.long[j]+DoubleToStr(LOW+(range[1]*cz.level.array[j]),Digits);
         ObjectSetFiboDescription(s,j,d);
      }
   }
   
   if(target.short){
      HIGH = iHigh(NULL,PERIOD_W1,0);
      s = TAG+"CZLO";
      ObjectDelete(s);
      ObjectCreate(s, OBJ_FIBO, 0,TIME,HIGH-range[1],TIME,HIGH);
      ObjectSet(s, OBJPROP_COLOR, CLR_NONE);
      ObjectSet(s, OBJPROP_STYLE, line.style);
      ObjectSet(s, OBJPROP_WIDTH, line.width);
      ObjectSet(s, OBJPROP_RAY, true);
      ObjectSet(s, OBJPROP_BACK, true);   
      ObjectSet(s, OBJPROP_FIBOLEVELS, level_count);
      ObjectSet(s, OBJPROP_LEVELCOLOR, color.cz.short);

      for(j=0; j<level_count; j++){
         ObjectSet(s, OBJPROP_FIRSTLEVEL+j, cz.level.array[j]);
         d = cz.level.desc.short[j]+DoubleToStr(HIGH-(range[1]*cz.level.array[j]),Digits);
         ObjectSetFiboDescription(s,j,d);
      }
   }
   return(0);
}


